package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleEvt;
import com.njcn.energy.pojo.po.EleMd;
import com.njcn.energy.service.IEleEvtService;
import com.njcn.energy.service.IEleMdService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 15:08
 */
@Slf4j
@RestController
@RequestMapping("/evt")
@RequiredArgsConstructor
@Api(tags = "设备事件数据管理")
public class EleEvtController extends BaseController {

    private final IEleEvtService eleEvtService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增设备事件数据")
    @ApiImplicitParam(name = "eleEvt", value = "设备事件数据", required = true)
    public HttpResult<EleEvt> add(@RequestBody EleEvt eleEvt){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，设备事件数据：{}", methodDescribe, eleEvt);
        EleEvt result = eleEvtService.addEvt(eleEvt);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改设备事件数据")
    @ApiImplicitParam(name = "eleEvt", value = "设备事件数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleEvt eleEvt){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，设备事件数据：{}", methodDescribe, eleEvt);
        boolean result = eleEvtService.updateEvt(eleEvt);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParam(name = "name", value = "名称", required = true)
    public HttpResult<EleEvt> findByName(@RequestParam String name){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleEvt eleEvt = eleEvtService.findByName(name);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleEvt, methodDescribe);
    }

}
